REM Mermaid
REM (c) 2015 Tuatara Software

REM Concept and Artwork - R.C. Bain
REM Programming, Music, Sound Effects - Derek Bain
REM Castle Layout - R.C. Bain, B.K. Bain, M.L. Bain, Derek Bain

'       Increase the memory capacity!!
        GOTO Start
        ASM ORG $C040
Start:  WAIT


'initialize

	INCLUDE "constants.bas"
	'foreground/background mode
	MODE SCREEN_FOREGROUND_BACKGROUND
	WAIT
	DEFINE 0,15,screen_bitmaps_0
	WAIT
	SCREEN screen_title
	
	gosub WAITALOT

Rem Setup arrays for holding 8 sprites x,y locations and color
Dim Spritex (8)
Dim Spritey (8)
Dim #SpriteC (8)

Rem Setup array for castle layout (10x10 grid)
Dim castleLayout (100)

Rem Setup array for music notes
Dim note(3)

Rem Castle layout  (room numbers)
Rem 1	2	3	4	5	6	7	8	9	10
Rem 11	12	13	14	15	16	17	18	19	20
Rem 21	22	23	24	25	26	27	28	29	30
Rem 31	32	33	34	35	36	37	38	39	40
Rem 41	42	43	44	45	46	47	48	49	50
Rem 51	52	53	54	55	56	57	58	59	60
Rem 61	62	63	64	65	66	67	68	69	70
Rem 71	72	73	74	75	76	77	78	79	80
Rem 81	82	83	84	85	86	87	88	89	90
Rem 91	92	93	94	95	96	97	98	99	100

	
reset:

#score = 0
level = 0
#bubble_counter = 45
#boost_counter = 144
#merChange_counter = 24
#countdownTimer = 9600
diffLevel = 0
mermaid = 0
levelSelect = 0
mermaidSelect = 0
'mermaidFacing keeps track of her direction 0-Left 1-Right
mermaidFacing = 0
#mermaid_color = SPR_GREEN
'startIntroMusic = 0
lives = 5
waitkeypress = 0
mermaid_speed = 2
trace = 0
starting_point = 8
REM  mermaidLocation (0 = ocean, 1 = castle)
mermaidLocation = 0
REM  nextScreen (0 = no change, 1 = advance north, 2 = advance east 3 = advance south, 4 = advance west)
nextScreen = 0     
inventory_key = 0
inventory_crown = 0
inventory_gold = 0
inventory_silver = 0
key_visible = 0
crown_visible = 0
gold_position = 0
silver_position = 0
treasure = 0
soundFlag = 0
sound_duration=0
creature=0
creature1_Facing=0
creature1_Frame=0
creature1_Timer=0
creature1_Speed=0
queen_visible = 0
lives1UPFlag = 0

Rem sprite#0 is Mermaid1
Spritex(0)=160
Spritey(0)=60
#SpriteC(0)=SPR_YELLOW

Rem sprite#1 is Mermaid2
Spritex(1)=160
Spritey(1)=60
#SpriteC(1)=#mermaid_color

Rem sprite#2 is Bubble
Spritex(2)=160
Spritey(2)=60
#SpriteC(2)=SPR_CYAN

title_screen:
'cls
wait

Rem Define sprites
DEFINE DEF32,16,sprites
wait
DEFINE DEF48,16,moreSprites

PRINT AT 22 COLOR FG_GREEN+BG_BLUE,"TUATARA SOFTWARE"
PRINT AT 46 COLOR FG_YELLOW+BG_BLUE,"PRESENTS"
PRINT AT 84 COLOR FG_WHITE+BG_BLUE,"MERMAID V0.08"

PRINT AT SCREENPOS(1, 9) COLOR FG_TAN+BG_BLUE,"DIFFICULTY (1-4) ?"

VOICE INIT
VOICE PLAY tuatara
VOICE PLAY software
VOICE PLAY presents
GOSUB waitabit
VOICE PLAY mermaid
Play Simple
''Play Intro_Tune
GOSUB introSwimBy	
PLAY NONE

nextLevel:

level = level + 1

'castle will be on random screen each level based on current level # and user-selected difficulty level

GOSUB levelRandomizer

GOSUB merColor


main:
cls
resetsprite(0):resetsprite(1):resetsprite(2):resetsprite(3):resetsprite(4):resetsprite(5):resetsprite(6):resetsprite(7)
Rem first sprite is Mermaid1
Spritex(0)=80
Spritey(0)=60
#SpriteC(0)=SPR_YELLOW

Rem second sprite is Mermaid2  
Spritex(1)=80
Spritey(1)=60
#SpriteC(1)=#mermaid_color

''Rem sprite#3 is creature-left
Spritex(3)=80
Spritey(3)=20
#SpriteC(3)=SPR_GREY

''Rem sprite#4 is creature-right
Spritex(4)=88
Spritey(4)=20
#SpriteC(4)=SPR_GREY

''Rem sprite#5 is queen
Spritex(5)=70
Spritey(5)=48
#SpriteC(5)=SPR_PINK

''Rem sprite#6 is queen2
Spritex(6)=70
Spritey(6)=48
#SpriteC(6)=SPR_YELLOW

''Rem sprite#7 is queen's sceptre
Spritex(7)=54
Spritey(7)=48
#SpriteC(7)=SPR_TAN

'reset bubbles and boost to 3
bubbles = 3: boost = 3 : merChange = 1
GOSUB update_bubble_counter:GOSUB update_boost_counter:GOSUB update_merChange_counter

#countdownTimer = ((5-level)*2400)/diffLevel 
inventory_crown = 0
inventory_key = 0
queen_visible = 0
queen_counter=0
queen_frame=0

mermaidLocation=0

SCREEN screen_level
GOSUB update_score
PLAY Simple
PLAY Game_Tune

game_loop:


''if mermaidFacing=0 then Sprite 0,Spritex(0)+VISIBLE+ZOOMX2,Spritey(0)+ZOOMY2, SPR32+ (8*spriteframe) +#SpriteC(0) else Sprite 0,Spritex(0)+VISIBLE+ZOOMX2,Spritey(0)+ZOOMY2+FLIPX, SPR32+ (8*spriteframe) +#SpriteC(0)
if mermaidFacing=0 then Sprite 0,Spritex(0)+VISIBLE+HIT+ZOOMX2,Spritey(0)+ZOOMY2, SPR32+ (8*spriteframe) +#SpriteC(0) else Sprite 0,Spritex(0)+VISIBLE+HIT+ZOOMX2,Spritey(0)+ZOOMY2+FLIPX, SPR32+ (8*spriteframe) +#SpriteC(0)
if mermaidFacing=0 then Sprite 1,Spritex(1)+VISIBLE+ZOOMX2,Spritey(1)+ZOOMY2, SPR36+ (8*spriteframe) +#SpriteC(1) else Sprite 1,Spritex(1)+VISIBLE+ZOOMX2,Spritey(1)+ZOOMY2+FLIPX, SPR36+ (8*spriteframe) +#SpriteC(1)

'reposition creature
IF creature>0 AND creature<7 THEN GOSUB moveCreature
IF creature>0 AND creature<7 THEN GOSUB display_creature

IF creature>0 AND creature<7 THEN GOSUB moveCreature:GOSUB display_creature

IF queen_visible = 1 THEN GOSUB displayQueen

gosub waitalittle
Spriteframe=Spriteframe+1:If SpriteFrame>3 then SpriteFrame=0
if creature>0 AND creature<7 THEN creature1_timer=creature1_Timer+1:If creature1_timer<4 THEN creature1_frame=0 ELSE creature1_frame=1
if creature1_timer>10 THEN creature1_timer=0

'print gold bar, silver coin or crown
'gold bar = $2C39
IF mermaidLocation = 0 AND inventory_gold = 0 AND gold_position > 0 THEN PRINT AT 180+gold_position, $2C39:gold_visible=1 ELSE PRINT AT 180+gold_position, $0200
'silver coin = $1841
IF mermaidLocation = 0 AND inventory_silver = 0 AND silver_position > 0 THEN PRINT AT 180+silver_position, $1841:silver_visible=1 ELSE PRINT AT 180+silver_position, $0200
'crown = $3849
IF mermaidLocation = 0 AND mermaid_oceanLocation = crownLocation AND inventory_crown = 0 THEN PRINT AT 180+crownPosition, $3849:crown_visible=1 ELSE PRINT AT 180+crownPosition, $0200
'key = $2E51
IF mermaidLocation = 0 AND mermaid_oceanLocation = keyLocation AND inventory_key = 0 THEN PRINT AT 180+keyPosition, $2E51:key_visible=1 ELSE PRINT AT 180+keyPosition, $0200
'place the castle
IF mermaidLocation = 0 AND mermaid_oceanLocation = castleLocation THEN GOSUB castle_Placement
'place the queen's throne
IF mermaidLocation = 1 AND mermaid_CastleLocation = queenLocation AND queen_visible = 0 THEN queen_visible = 1

IF queen_visible = 1 THEN GOSUB displayQueen

'check for controller movement, reposition mermaid
IF cont.left THEN 
	IF mermaidLocation=0 THEN 
		IF Spritex(0) > 4 THEN GOSUB mermaid_moveLeft ELSE nextScreen = 4: GOSUB mermaid_moveLeft
	ELSE
		IF Spritex(0) > 14 THEN	
			GOSUB mermaid_moveLeft
		ELSE 
			''IF Spritex(0) > 12 AND Spritex(0) <= 14 THEN nextScreen = 4: GOSUB mermaid_moveLeft
			IF Spritex(0) >= 12 AND Spritex(0) <= 16 THEN nextScreen = 4: GOSUB mermaid_moveLeft
		END IF
	END IF
END IF

IF cont.right THEN 
	IF mermaidLocation=0 THEN 
		IF Spritex(0) < 156 THEN GOSUB mermaid_moveRight ELSE nextScreen = 2: GOSUB mermaid_moveRight
	ELSE
		IF Spritex(0) < 146 THEN 
			GOSUB mermaid_moveRight
		ELSE
			''IF Spritex(0) >= 146 and Spritex(0) < 148 THEN nextScreen = 2: GOSUB mermaid_moveRight
			IF Spritex(0) >= 144 and Spritex(0) <= 148 THEN nextScreen = 2: GOSUB mermaid_moveRight
		END IF
	END IF
END IF

IF cont.up THEN 
	IF mermaidLocation=0 THEN 
		IF Spritey(0) > 8 THEN GOSUB mermaid_moveUp 
	ELSE
		IF Spritey(0) > 14 THEN
			GOSUB mermaid_moveUp
		ELSE
			''IF Spritey(0) > 12 and Spritey(0) <= 14 THEN nextScreen = 1: GOSUB mermaid_moveUp 
			IF Spritey(0) >= 12 and Spritey(0) <= 16 THEN nextScreen = 1: GOSUB mermaid_moveUp 
		END IF
	END IF
END IF

IF cont.down THEN 
	IF mermaidLocation=0 THEN 
		IF Spritey(0) < 86 THEN GOSUB mermaid_moveDown
	ELSE
		IF Spritey(0) < 88 THEN 
			GOSUB mermaid_moveDown
		ELSE
			''IF Spritey(0) >=88 and Spritey(0) < 90 THEN nextScreen = 3: GOSUB mermaid_moveDown
			IF Spritey(0) >=88 and Spritey(0) <= 92 THEN nextScreen = 3: GOSUB mermaid_moveDown
		END IF
	END IF
END IF	

IF bubbles > 0 AND bubble_active = 0 THEN IF cont.B0 THEN bubble_active = 1:bubbles=bubbles-1:Spritex(2)=Spritex(0):Spritey(2)=Spritey(0):soundFlag=5 : GOSUB loadSound
IF bubble_active = 1 THEN #bubble_counter=#bubble_counter-1:Sprite 2,Spritex(2)+VISIBLE+ZOOMX2,Spritey(2)+ZOOMY2, SPR40+#SpriteC(2)
''IF #bubble_counter = 0 then bubble_active = 0:GOSUB update_bubble_counter:Sprite 2,Spritex(2)+ZOOMX2,Spritey(2)+ZOOMY2, SPR40+#SpriteC(2)
IF #bubble_counter = 0 then bubble_active = 0:GOSUB update_bubble_counter:resetsprite(2)

IF boost > 0 AND boost_active = 0 THEN 
	IF cont.B2 THEN 
		boost_active = 1:boost=boost-1
		IF merChange_active = 0 THEN mermaid_speed=mermaid_speed*2
		soundFlag=7 
		GOSUB loadSound
	END IF
END IF
IF boost_active = 1 THEN #boost_counter=#boost_counter-1
IF #boost_counter = 0 then boost_active = 0:mermaid_speed=mermaid_speed/2:GOSUB update_boost_counter

IF merChange > 0 AND merChange_active = 0 THEN 
	IF cont.B1 THEN 
		merChange_active = mermaid
		perform_merChange:
		mermaid=RANDOM(5)+1 : IF mermaid = merChange_active GOTO perform_merChange 
		GOSUB merColor
		merChange=merChange-1
		if boost_active = 0 THEN mermaid_speed=mermaid_speed*2
		Spritex(2)=Spritex(0):Spritey(2)=Spritey(0)
		bubble_active=1:boost_active=1
		soundFlag=7
		GOSUB loadSound
	END IF
END IF
IF merChange_active > 0 THEN #merChange_counter=#merChange_counter-1
IF #merChange_counter = 0 then mermaid = merChange_active : merChange_active = 0 : GOSUB merColor: mermaid_speed=mermaid_speed/2: boost_active = 0 : bubble_active = 0: resetsprite(2): GOSUB update_merChange_counter

'if bubble_active=1 do not enforce collisions with sea creatures!
IF bubble_active=1 GOTO avoid_creature_collision

'check for collisions with sea creatures
IF COL0 AND HIT_SPRITE3 THEN 
	playerHit=creature:soundFlag=8:GOSUB loadSound
	'if shark hits player, move mermaid back to ocean starting position
	'if any other sea creature hits player, move back to starting position in current location (ocean or castle)
	IF creature=1 THEN mermaidLocation = 0 : GOSUB creatureCollisionOcean: GOTO avoid_creature_collision
	IF mermaidLocation = 0 THEN GOSUB creatureCollisionOcean ELSE GOSUB creatureCollisionCastle
END IF

'check for collisions with treasure, key, crown
avoid_creature_collision:

ON crown_visible GOTO skip_crown, detect_crown_collision

detect_crown_collision:
'if spriteY(0) >=78 AND spriteY(0) <=86 AND spriteX(0) >= (crownPosition*8)-6 AND spriteX(0) <= (crownPosition*8)+14 AND inventory_crown = 0 THEN inventory_crown = 1: soundFlag=1: #score=#score+250 : GOSUB loadSound : GOSUB check1up
if spriteY(0) > 78 AND spriteY(0) < 86 AND spriteX(0) > (crownPosition*8)-6 AND spriteX(0) < (crownPosition*8)+14 AND inventory_crown = 0 THEN inventory_crown = 1: soundFlag=1: #score=#score+250 : GOSUB loadSound : GOSUB check1up

skip_crown:

ON key_visible GOTO skip_key, detect_key_collision
detect_key_collision:
'if spriteY(0) >=78 AND spriteY(0) <=86 AND spriteX(0) >= (keyPosition*8)-6 AND spriteX(0) <= (keyPosition*8)+14 AND inventory_key = 0 THEN inventory_key = 1: soundFlag=2: #score=#score+100 : GOSUB loadSound : GOSUB check1up
if spriteY(0) > 78 AND spriteY(0) < 86 AND spriteX(0) > (keyPosition*8)-6 AND spriteX(0) < (keyPosition*8)+14 AND inventory_key = 0 THEN inventory_key = 1: soundFlag=2: #score=#score+100 : GOSUB loadSound : GOSUB check1up

skip_key:

ON gold_visible GOTO skip_gold, detect_gold_collision
detect_gold_collision:
'if spriteY(0) >=78 AND spriteY(0) <=86 AND spriteX(0) >= (gold_position*8)-6 AND spriteX(0) <= (gold_position*8)+14 AND inventory_gold = 0 THEN inventory_gold = 1: soundFlag=3: #score=#score+50 : GOSUB loadSound : GOSUB check1up
if spriteY(0) > 78 AND spriteY(0) < 86 AND spriteX(0) > (gold_position*8)-6 AND spriteX(0) < (gold_position*8)+14 AND inventory_gold = 0 THEN inventory_gold = 1: soundFlag=3: #score=#score+50 : GOSUB loadSound : GOSUB check1up

skip_gold:

ON silver_visible GOTO skip_silver, detect_silver_collision
detect_silver_collision:
'if spriteY(0) >=78 AND spriteY(0) <=86 AND spriteX(0) >= (silver_position*8)-6 AND spriteX(0) <= (silver_position*8)+14 AND inventory_silver = 0 THEN inventory_silver = 1: soundFlag=4: #score=#score+10 : GOSUB loadSound : GOSUB check1up
if spriteY(0) > 78 AND spriteY(0) < 86 AND spriteX(0) > (silver_position*8)-6 AND spriteX(0) < (silver_position*8)+14 AND inventory_silver = 0 THEN inventory_silver = 1: soundFlag=4: #score=#score+10 : GOSUB loadSound : GOSUB check1up

skip_silver:

'check for castle collision if mermaid has the key and crown
IF mermaidLocation = 0 AND mermaid_oceanLocation = castleLocation AND soundFlag<> 6 THEN
	IF spriteY(0) > 56 AND spriteY(0) < 90 AND spriteX(0) > 72 AND spriteX(0) < 103 AND inventory_key = 1 AND inventory_crown = 1 THEN soundFlag=6: GOSUB loadSound : GOSUB check1up
END IF

ON queen_visible GOTO skip_queen, detect_queen_collision
detect_queen_collision:
IF spriteY(0) > 30 AND spriteY(0) < 66 AND spriteX(0) > 72 AND spriteX(0) < 88 THEN GOTO level_complete

skip_queen:

IF sound_duration > 0 AND sound_duration < 3 then sound_duration=sound_duration+1:SOUND 2,note(1),15-(sound_duration*2)/16:SOUND 4,note(1),$18:spritex(0)=spritex(1)
IF sound_duration > 2 AND sound_duration < 6 then sound_duration=sound_duration+1:SOUND 2,note(2),15-(sound_duration*2)/16:SOUND 4,note(2),$18:spritex(0)=spritex(1)
IF sound_duration > 5 AND sound_duration < 9 then sound_duration=sound_duration+1:SOUND 2,note(3),15-(sound_duration*2)/16:SOUND 4,note(3),$18:spritex(0)=spritex(1)
IF sound_duration > 8 THEN GOSUB noSound

#countdownTimer = #countdownTimer - 1 
if #countdownTimer = 0 THEN gosub lose_life: GOTO main

'check for trace enable/disable   (press 'CLEAR' on the keypad)
'IF cont.key <> 12 GOTO skip_check_trace
'WAIT
IF cont.key = 10 THEN trace=trace+1
'remove trace information from screen when trace mode is disabled
IF trace>1 THEN trace=0: IF mermaidLocation = 0 THEN SCREEN screen_level ELSE SCREEN castle_level: GOSUB display_castle_walls 

''crown&key - cheat_mode
''IF cont.key = 8 THEN inventory_crown = 1: inventory_key = 1

'skip_check_trace:

GOSUB update_score
	GOTO game_loop

	
crownSound:
DATA $03F9,$00FE,$0040
keySound:
DATA $0039,$0040,$0047
goldSound:
DATA $006B,$0065,$005A
silverSound:
DATA $04B9,$0435,$03C0
bubbleSound:
DATA $0357,$02A7,$023B
castleSound:
DATA $01FC,$01C5,$01AC
boostSound:
DATA $00AA,$00E2,$0030
creatureCollisionSound:
DATA $0780,$0973,$0C9D
lives1UPSound:
DATA $0026,$0022,$001E

thump_Sound:   Procedure
SOUND 2,$08EB,8:SOUND 4,$08EB,$18
SOUND 2,1,0:SOUND 4,1,$38:WAIT
END


loadSound:   Procedure
REM soundFlag (1=crown, 2=key, 3=gold, 4=silver, 5=bubble, 6=castle, 7=boost, 9=1UP)
IF soundFlag = 1 THEN RESTORE crownSound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 2 THEN RESTORE keySound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 3 THEN RESTORE goldSound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 4 THEN RESTORE silverSound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 5 THEN RESTORE bubbleSound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 6 THEN RESTORE castleSound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 7 THEN RESTORE boostSound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 8 THEN RESTORE creatureCollisionSound: READ note(1),note(2),note(3):sound_duration=1
IF soundFlag = 9 THEN RESTORE lives1UPSound: READ note(1),note(2),note(3):sound_duration=1
spritex(0)=spritex(1)
END

noSound:   Procedure
SOUND 2,1,0:SOUND 4,1,$38:WAIT
IF soundFlag = 1 THEN crown_visible=0
IF soundFlag = 2 THEN key_visible=0
IF soundFlag = 3 THEN gold_visible=0
IF soundFlag = 4 THEN silver_visible=0
IF soundFlag = 6 THEN mermaidLocation=1:#score=#score+500:GOSUB check1up:GOSUB waitabit:gosub castle_walls
soundFlag = 0:sound_duration=0:spritex(0)=spritex(1)
END

	' 13 bitmaps
screen_bitmaps_0:
	DATA $FFFF,$FFFF,$13BF,$0000
	DATA $FFFF,$FFFF,$8CFF,$0000
	DATA $FFFF,$FFFF,$038F,$0001
	DATA $EBFF,$EFF7,$FBF7,$EBE7
	DATA $EBFF,$FBD7,$E5D5,$F5EB
	DATA $6666,$0000,$0000,$0000
	DATA $0000,$8100,$0081,$0000
	DATA $FFFF,$FFFF,$8181,$FF81
	DATA $FFFF,$FFFF,$C3E7,$FFE7
	DATA $FFFF,$A5FF,$8181,$FFC3
	DATA $FFFF,$FFFF,$41BF,$FFB5
	DATA $1818,$C324,$24C3,$1818
	DATA $81C3,$1800,$0018,$C381
	DATA $7E42,$7E7E,$7E7E,$7E7E
	DATA $8142,$8181,$81FF,$8181
	
	REM 20x12 cards
screen_title:
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$2A21,$0200,$0200,$0200,$2A21,$0200,$0200,$0200,$0200,$0200,$2A19,$0200,$0200,$0200,$0200,$0200
	DATA $2C01,$2C09,$2C11,$0200,$2A19,$0200,$2C01,$2C09,$2C11,$0200,$2A19,$0200,$2C01,$2C09,$2C11,$0200,$2A21,$2C01,$2C09,$2C11
	DATA $2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400

screen_level:
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$2A21,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$2A19,$0200,$0200,$0200,$0200,$0200
	DATA $2C01,$2C09,$2C11,$0200,$2A19,$0200,$2C01,$2C09,$0200,$2C01,$2C09,$0200,$2C01,$2C09,$2C11,$0200,$2A21,$2C01,$2C09,$2C11
	DATA $2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400,$2400

castle_level:
	DATA $1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$0200,$0200,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $1860,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$1860
	DATA $1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$0200,$0200,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858,$1858

REM castle_placement displays the castle in the ocean when the mermaid is on the appropriate screen
	
castle_placement:   Procedure
PRINT AT 108,$1829
PRINT AT 111,$1829
PRINT AT 128,$1831
PRINT AT 129,$1829
PRINT AT 130,$1829
PRINT AT 131,$1831

FOR a = 148 TO 208 STEP 20
	FOR b = 0 TO 3
		PRINT AT a+b,$1831
	NEXT b
NEXT a

END	
	
tuatara:     VOICE TT1,UW2,PA1,UH,PA1,TT1,AR,PA1,UH,PA2,0
software:    VOICE SS,UH,FF,TT1,WH,ER2,PA2,0
presents:    VOICE PP,RR1,IY,ZZ,EH,NN1,TT1,SS,PA2,0
mermaid:     VOICE MM,ER1,MM,EY,DD1,PA1,0

WaitTitleDiffSelect:Procedure
	For a=0 to 5
		wait
		'check for key press on either controller
    	'set difficulty level based on user input
		'IF levelSelect = 0 then IF cont.key >= 1 AND cont.key <= 4 THEN levelSelect=1:diffLevel = cont.key:EXIT FOR
		IF cont.key >= 1 AND cont.key <= 4 THEN levelSelect=1:diffLevel = cont.key:waitkeypress = 1:PRINT AT SCREENPOS(1, 10) COLOR FG_WHITE+BG_BLUE,"MERMAID (1-5) ?":EXIT FOR
	Next a
End

WaitTitleMermaidSelect:Procedure
	For a=0 to 5
		wait
		'check for key press on either controller
    	'select mermaid based on user input
		'IF mermaidSelect = 0 then IF cont.key >= 1 AND cont.key <= 5 THEN mermaidSelect=1:mermaid = cont.key:EXIT FOR	
		if waitkeypress > 10 then IF cont.key >= 1 AND cont.key <= 5 THEN mermaidSelect=1:mermaid = cont.key:waitkeypress = 0:EXIT FOR	
		'IF cont.key >= 1 AND cont.key <= 5 THEN mermaidSelect=1:mermaid = cont.key:EXIT FOR	
	Next a
End

WaitaLittle:Procedure
	For a=0 to 5
		wait
	Next a
End

WaitaBit:Procedure
	For a=0 to 10
		Wait
	Next a
End

WaitaLot:Procedure
	For a=0 to 8
		gosub waitabit
	next a
End

introSwimBy: Procedure
	Spriteframe=0
        For cnt1=160 to 20 step -2
			'large mermaid
			Sprite 0,Spritex(0)+VISIBLE+ZOOMX2,Spritey(0)+ZOOMY2, SPR32+ (8*spriteframe) +#SpriteC(0)
			Sprite 1,Spritex(1)+VISIBLE+ZOOMX2,Spritey(1)+ZOOMY2, SPR36+ (8*spriteframe) +#SpriteC(1)
			if levelSelect=0 then gosub waitTitleDiffSelect else gosub waitTitleMermaidSelect
			if levelSelect=1 and mermaidSelect=1 GOTO introDone
			if waitkeypress > 0 then waitkeypress = waitkeypress + 1
			Spriteframe=Spriteframe+1:If SpriteFrame>3 then SpriteFrame=0
			Spritex(0)=Spritex(0)-2: Spritex(1)=Spritex(1)-2
			If Spritex(0)<20 then Spritex(0)=160:Spritex(1)=160
			'If Spritex(1)<20 then Spritex(1)=160
		next cnt1
	startIntroMusic=startIntroMusic+1
	if startIntroMusic=1 then Play Intro_Tune
	goto introSwimBy
	'exiting subroutine, set levelSelect back to zero
	introDone:
End

update_score:	Procedure
ON mermaidLocation GOTO update_score_ocean, update_score_castle
update_score_ocean:

	PRINT AT SCREENPOS(1, 0) COLOR FG_WHITE+BG_BLUE,<>#score
	PRINT AT SCREENPOS(7, 0) COLOR FG_WHITE+BG_BLUE,<>level
	PRINT AT SCREENPOS(1, 11) COLOR FG_GREEN+BG_BLUE,<>mermaid_oceanLocation
	PRINT AT SCREENPOS(4, 11) COLOR FG_GREEN+BG_BLUE,<>ocean_level_width
	PRINT AT SCREENPOS(15, 11) COLOR FG_YELLOW+BG_BLUE,<>lives
	PRINT AT SCREENPOS(17, 11) COLOR FG_TAN+BG_BLUE,<>bubbles
	PRINT AT SCREENPOS(19, 11) COLOR FG_RED+BG_BLUE,<>boost
	'print ocean tiles as countdown timer decreases
    FOR a = 0 TO 3
		PRINT AT 16+a,$0200
	NEXT a
	IF #countdownTimer > 999 THEN 
		PRINT AT SCREENPOS(16, 0) COLOR FG_WHITE+BG_BLUE,<>#countdownTimer
	ELSEIF #countdownTimer > 99 THEN
		PRINT AT SCREENPOS(17, 0) COLOR FG_WHITE+BG_BLUE,<>#countdownTimer 
	ELSE 
		IF #countdownTimer > 9 THEN PRINT AT SCREENPOS(18, 0) COLOR FG_WHITE+BG_BLUE,<>#countdownTimer ELSE PRINT AT SCREENPOS(19, 0) COLOR FG_WHITE+BG_BLUE,<>#countdownTimer
	END IF
	GOTO update_score_trace

update_score_castle:

	PRINT AT SCREENPOS(1, 0) COLOR FG_WHITE+BG_GREY,<>#score
	PRINT AT SCREENPOS(7, 0) COLOR FG_WHITE+BG_GREY,<>level
	PRINT AT SCREENPOS(1, 11) COLOR FG_WHITE+BG_GREY,<>mermaid_castleLocationX
	PRINT AT SCREENPOS(4, 11) COLOR FG_WHITE+BG_GREY,<>mermaid_castleLocationY
	PRINT AT SCREENPOS(15, 11) COLOR FG_YELLOW+BG_GREY,<>lives
	PRINT AT SCREENPOS(17, 11) COLOR FG_TAN+BG_GREY,<>bubbles
	PRINT AT SCREENPOS(19, 11) COLOR FG_RED+BG_GREY,<>boost
	'print ocean tiles as countdown timer decreases
    FOR a = 0 TO 3
		PRINT AT 16+a,$0200
	NEXT a
	IF #countdownTimer > 999 THEN 
		PRINT AT SCREENPOS(16, 0) COLOR FG_WHITE+BG_GREY,<>#countdownTimer
	ELSEIF #countdownTimer > 99 THEN
		PRINT AT SCREENPOS(17, 0) COLOR FG_WHITE+BG_GREY,<>#countdownTimer 
	ELSE 
		IF #countdownTimer > 9 THEN PRINT AT SCREENPOS(18, 0) COLOR FG_WHITE+BG_GREY,<>#countdownTimer ELSE PRINT AT SCREENPOS(19, 0) COLOR FG_WHITE+BG_GREY,<>#countdownTimer
	END IF
	
	
update_score_trace:	
'only display trace information when TRACE = 1
	IF trace = 1 then
		PRINT AT SCREENPOS(6, 1) COLOR FG_TAN+BG_BLUE,<>#bubble_counter
		PRINT AT SCREENPOS(16, 1) COLOR FG_TAN+BG_BLUE,<>level
		PRINT AT SCREENPOS(18, 1) COLOR FG_TAN+BG_BLUE,<>diffLevel
		PRINT AT SCREENPOS(2, 2) COLOR FG_RED+BG_BLUE,<>Spritex(0)
		PRINT AT SCREENPOS(6, 2) COLOR FG_RED+BG_BLUE,<>Spritey(0)
		PRINT AT SCREENPOS(10, 2) COLOR FG_TAN+BG_BLUE,<>#boost_counter
		PRINT AT SCREENPOS(15, 2) COLOR FG_WHITE+BG_BLUE,<>inventory_key
		PRINT AT SCREENPOS(17, 2) COLOR FG_RED+BG_BLUE,<>inventory_crown
		PRINT AT SCREENPOS(2, 3) COLOR FG_RED+BG_BLUE,<>Spritex(1)
		PRINT AT SCREENPOS(6, 3) COLOR FG_RED+BG_BLUE,<>Spritey(1)
		PRINT AT SCREENPOS(15, 3) COLOR FG_WHITE+BG_BLUE,<>keyPosition
		PRINT AT SCREENPOS(17, 3) COLOR FG_RED+BG_BLUE,<>crownPosition
		junk = (crownPosition*8)-6:PRINT AT SCREENPOS(1, 4) COLOR FG_RED+BG_BLUE,<>junk 
		junk = (crownPosition*8)+14:PRINT AT SCREENPOS(5, 4) COLOR FG_RED+BG_BLUE,<>junk 
		PRINT AT SCREENPOS(8, 4) COLOR FG_GREEN+BG_BLUE,<>treasure
		PRINT AT SCREENPOS(10, 4) COLOR FG_YELLOW+BG_BLUE,<>gold_position
		PRINT AT SCREENPOS(12, 4) COLOR FG_TAN+BG_BLUE,<>silver_position
		PRINT AT SCREENPOS(15, 4) COLOR FG_WHITE+BG_BLUE,<>key_visible
		PRINT AT SCREENPOS(17, 4) COLOR FG_RED+BG_BLUE,<>crown_visible
		junk = (keyPosition*8)-6:PRINT AT SCREENPOS(1, 5) COLOR FG_WHITE+BG_BLUE,<>junk 
		junk = (keyPosition*8)+14:PRINT AT SCREENPOS(4, 5) COLOR FG_WHITE+BG_BLUE,<>junk 
		PRINT AT SCREENPOS(9, 5) COLOR FG_TAN+BG_BLUE,<>Spritex(3)
		PRINT AT SCREENPOS(12, 5) COLOR FG_TAN+BG_BLUE,<>Spritey(3)
		PRINT AT SCREENPOS(7, 6) COLOR FG_GREEN+BG_BLUE,<>spawnPoint
		PRINT AT SCREENPOS(9, 6) COLOR FG_TAN+BG_BLUE,<>Spritex(4)
		PRINT AT SCREENPOS(12, 6) COLOR FG_TAN+BG_BLUE,<>Spritey(4)			
		PRINT AT SCREENPOS(1, 7) COLOR FG_TAN+BG_BLUE,<>creature
		PRINT AT SCREENPOS(4, 7) COLOR FG_YELLOW+BG_BLUE,<>creature1_Speed
		PRINT AT SCREENPOS(7, 7) COLOR FG_YELLOW+BG_BLUE,<>creature1_Speed
		PRINT AT SCREENPOS(10, 7) COLOR FG_WHITE+BG_BLUE,<>castleLayout(mermaid_CastleLocation)
		PRINT AT SCREENPOS(13, 7) COLOR FG_GREEN+BG_BLUE,<>nextScreen
		'PRINT AT SCREENPOS(15, 7) COLOR FG_GREEN+BG_BLUE,<>dir
		PRINT AT SCREENPOS(15, 7) COLOR FG_GREEN+BG_BLUE,<>queenLocation
		PRINT AT SCREENPOS(1, 8) COLOR FG_TAN+BG_BLUE,<>creature1_UpDown
		PRINT AT SCREENPOS(3, 8) COLOR FG_TAN+BG_BLUE,<>creature1_UpDown_Speed		
		PRINT AT SCREENPOS(5, 8) COLOR FG_RED+BG_BLUE,<>playerHit	
		PRINT AT SCREENPOS(7, 8) COLOR FG_RED+BG_BLUE,<>mermaid
		PRINT AT SCREENPOS(15, 8) COLOR FG_RED+BG_BLUE,<>mermaid_CastleLocation
		PRINT AT SCREENPOS(7, 10) COLOR FG_WHITE+BG_BLUE,<>castleLocation
		PRINT AT SCREENPOS(15, 10) COLOR FG_WHITE+BG_BLUE,<>keyLocation
		PRINT AT SCREENPOS(17, 10) COLOR FG_RED+BG_BLUE,<>crownLocation
	END IF 
END

update_bubble_counter:    Procedure
if level > 0 and level < 5 then #bubble_counter = ((5-level)*72)/diffLevel 
if #bubble_counter < 36 then #bubble_counter = 36
END 

update_boost_counter:    Procedure
if level > 0 and level < 5 then #boost_counter = ((5-level)*36)/diffLevel 
if #boost_counter < 18 then #boost_counter = 18
END 

update_merChange_counter:    Procedure
if level > 0 and level < 5 then #merChange_counter = ((5-level)*24)/diffLevel 
if #boost_counter < 12 then #boost_counter = 12
END 

levelRandomizer:    Procedure
REM      Ocean screens are 15 to 90 screens wide  (screen wraps from 90 to 1 and vice versa)
REM 	 ocean_level_width = diffLevel*level*15
REM      Mermaid always begins in the center location 
REM           starting_point = (ocean_level_width+1)/2
REM      Castles are 10x10 grids

ocean_level_width = diffLevel*level*15
if ocean_level_width > 90 then ocean_level_width = 90
starting_point = (ocean_level_width+1)/2
mermaid_castleLocationX = 0
mermaid_castleLocationY = 0
mermaid_oceanLocation = starting_point
castleLocation = RANDOM(ocean_level_width)+1
keyLocation = RANDOM(ocean_level_width)+1
keyPosition = RANDOM(18)+2
crownLocation = RANDOM(ocean_level_width)+1
crownPosition = RANDOM(18)+2
'avoid placing queen in the castle entrance
queenRandomizer:
queenLocation = RANDOM(100)+1: IF queenLocation = 95 GOTO queenRandomizer

'avoid placing key and crown in a castle tile
if keyPosition >= 9 and keyPosition <= 12 and castleLocation = keyLocation then keyPosition = 15
if crownPosition >= 9 and crownPosition <= 12 and castleLocation = crownLocation then crownPosition = 5

'avoid placing key and crown on the same tile
if keyPosition = crownPosition AND keyLocation = crownLocation THEN keyPosition = 5: crownPosition = 15

END

mermaid_moveLeft:    Procedure
IF nextScreen = 0 THEN 
	GOTO all_left 
ELSE 
	ON mermaidLocation GOTO ocean_left, castle_left
END IF

ocean_left:
nextScreen = 0
SCREEN screen_level
GOSUB treasure_placement:GOSUB creature_placement
mermaid_oceanLocation = mermaid_oceanLocation-1
IF mermaid_oceanLocation < 1 THEN mermaid_oceanLocation = ocean_level_width
Spritex(0) = 150: Spritex(1) = 150: Spritex(2) = 150
'display new scene

GOTO all_left

castle_left:
'determine if castle room permits movement to the west 
ON castleLayout(mermaid_CastleLocation) GOTO ,room_west,,room_west,,room_west,,room_west,,,,room_west,,room_west,room_west,room_west
'if west wall is blocked, skip ahead to all_left 
dir=0
GOTO all_left

room_west:
'determine if mermaid is properly aligned with opening
'IF Spritey(0) > 40 and Spritey(0) < 56 and nextScreen > 0 and spriteX(0)<=14 THEN 
IF Spritey(0) > 40 and Spritey(0) < 56 and nextScreen > 0 and spriteX(0)<=16 THEN 
	IF mermaid_castleLocationX > 1 THEN 
		mermaid_castleLocationX = mermaid_castleLocationX - 1: mermaid_CastleLocation = mermaid_CastleLocation - 1 
		Spritex(0) = 150: Spritex(1) = 150: Spritex(2) = 150 : dir = 1
		'display new scene
		SCREEN castle_level : GOSUB display_castle_walls : GOSUB treasure_placement : GOSUB creature_placement : GOTO finish_mermaid_left
	ELSE
		'bumped into castle wall, play bump sound
		if spriteX(0)<14 THEN dir = 2 : GOSUB thump_sound : GOTO finish_mermaid_left
	END IF
ELSE
	GOTO all_left
END IF

all_left:
Spritex(0) = Spritex(0) - mermaid_speed
Spritex(1) = Spritex(1) - mermaid_speed
Spritex(2) = Spritex(2) - mermaid_speed
if mermaidFacing=1 then mermaidFacing=0

finish_mermaid_left:
nextScreen = 0

END

mermaid_moveRight:    Procedure
IF nextScreen = 0 THEN 
	GOTO all_right 
ELSE 
	ON mermaidLocation GOTO ocean_right, castle_right
END IF

ocean_right:
nextScreen = 0
SCREEN screen_level
GOSUB treasure_placement:GOSUB creature_placement
mermaid_oceanLocation = mermaid_oceanLocation+1
IF mermaid_oceanLocation > ocean_level_width THEN mermaid_oceanLocation = 1
Spritex(0) = 10: Spritex(1) = 10: Spritex(2) = 10
'display new scene

GOTO all_right

castle_right:
'determine if castle room permits movement to the east 
ON castleLayout(mermaid_CastleLocation) GOTO ,room_east,,room_east,room_east,,room_east,,,,room_east,,room_east,,room_east,room_east
'if east wall is blocked, skip ahead to all_right
dir = 0
GOTO all_right

room_east:
'determine if mermaid is properly aligned with opening
'IF Spritey(0) > 40 and Spritey(0) < 56 and nextScreen > 0 and spriteX(0)>=146 THEN 
IF Spritey(0) > 40 and Spritey(0) < 56 and nextScreen > 0 and spriteX(0)>=144 THEN 
	IF mermaid_castleLocationX < 10 THEN 
		mermaid_castleLocationX = mermaid_castleLocationX + 1: mermaid_CastleLocation = mermaid_CastleLocation + 1 : nextScreen = 0
		Spritex(0) = 10: Spritex(1) = 10: Spritex(2) = 10 : dir = 1
		'display new scene
		SCREEN castle_level: GOSUB display_castle_walls : GOSUB treasure_placement : GOSUB creature_placement :GOTO finish_mermaid_right
	ELSE
		'bumped into castle wall, play bump sound
		if spriteX(0)>146 THEN dir = 2 : GOSUB thump_sound : GOTO finish_mermaid_right
	END IF
ELSE
	GOTO all_right	
END IF

all_right:

Spritex(0) = Spritex(0) + mermaid_speed
Spritex(1) = Spritex(1) + mermaid_speed
Spritex(2) = Spritex(2) + mermaid_speed
if mermaidFacing=0 then mermaidFacing=1

finish_mermaid_right:
nextScreen = 0

END

mermaid_moveUp:    Procedure
IF mermaidLocation = 0 THEN GOTO all_up 

'castle_up:
'determine if castle room permits movement to the north 
ON castleLayout(mermaid_CastleLocation) GOTO ,room_north,room_north,,room_north,room_north,,,room_north,,,,room_north,room_north,room_north,,
'if north wall is blocked, skip ahead to all_up
dir = 0
GOTO all_up

room_north:
'determine if mermaid is properly aligned with opening
'IF Spritex(0) > 70 and Spritex(0) < 90 and nextScreen > 0 and spriteY(0)<=14 THEN 
IF Spritex(0) > 70 and Spritex(0) < 90 and nextScreen > 0 and spriteY(0)<=16 THEN 
	IF mermaid_castleLocationY > 1 THEN 
		mermaid_castleLocationY = mermaid_castleLocationY - 1: mermaid_CastleLocation = mermaid_CastleLocation - 10
		Spritey(0) = 80: Spritey(1) = 80: Spritey(2) = 80 : dir = 1
		'display new scene
		SCREEN castle_level: GOSUB display_castle_walls : GOSUB treasure_placement : GOSUB creature_placement : GOTO finish_mermaid_up
	ELSE
		'bumped into castle wall, play bump sound
		if spriteY(0)<14 THEN dir = 2 : GOSUB thump_sound : GOTO finish_mermaid_up
	END IF
ELSE
	GOTO all_up
END IF

all_up:
'add code to advance to the next screen here
Spritey(0) = Spritey(0) - mermaid_speed
Spritey(1) = Spritey(1) - mermaid_speed
Spritey(2) = Spritey(2) - mermaid_speed

finish_mermaid_up:
nextScreen = 0 
END

mermaid_moveDown:   Procedure
IF mermaidLocation = 0 THEN GOTO all_down

'castle_down:
'determine if castle room permits movement to the south 
ON castleLayout(mermaid_CastleLocation) GOTO ,room_south,room_south,,,,room_south,room_south,,room_south,,,room_south,room_south,,room_south
'if south wall is blocked, skip ahead to all_down
dir = 0
GOTO all_down

room_south:
'determine if mermaid is properly aligned with opening

IF Spritex(0) > 70 and Spritex(0) < 90 and nextScreen > 0 and spriteY(0)>=88 THEN 
	IF mermaid_castleLocationY < 10 THEN 
		mermaid_castleLocationY = mermaid_castleLocationY + 1: mermaid_CastleLocation = mermaid_CastleLocation + 10
		Spritey(0) = 16 : Spritey(1) = 16 : Spritey(2) = 16 : dir = 1
		'display new scene
		SCREEN castle_level: GOSUB display_castle_walls : GOSUB treasure_placement : GOSUB creature_placement : GOTO finish_mermaid_down
	ELSE
		'bumped into castle wall, play bump sound
		if spriteY(0)>88 THEN dir = 2 : GOSUB thump_sound : GOTO finish_mermaid_down
	END IF
ELSE
	GOTO all_down
END IF

all_down:
'add code to advance to the next screen here
Spritey(0) = Spritey(0) + mermaid_speed
Spritey(1) = Spritey(1) + mermaid_speed
Spritey(2) = Spritey(2) + mermaid_speed

finish_mermaid_down:
nextScreen = 0
END

treasure_placement:   Procedure
'determine if treasure exists on this screen, if so what type(s)?
'if 1, place a gold bar and a silver coin
'if 2 or 3, place a gold bar
'if 10 through 12, place a silver coin
'if 4 through 9, no treasure
inventory_gold = 0
inventory_silver = 0
gold_position = 0
silver_position = 0
treasure = RANDOM(12)+1
IF treasure = 1 THEN gold_position = RANDOM(18)+2:silver_position = RANDOM(18)+2
IF gold_position > 0 AND gold_position=silver_position THEN IF gold_position < 18 THEN silver_position = gold_position+1 ELSE silver_position = gold_position-1
IF treasure > 1 AND treasure < 4 THEN gold_position = RANDOM(18)+2
IF treasure > 9 THEN silver_position = RANDOM(18)+2
END

creature_placement:   Procedure
'determine if creature(s) exist on this screen, if so what type(s)?
'if 1, place the shark
'if 2, place an octopus
'if 3, place a squid
'if 4 through 6, place fish
'if 7 through 12, no creatures

spawnPoint = RANDOM(6)+1
creature = RANDOM(12)+1
'hide sprites if creature random value between 7 and 12
IF creature>6 THEN resetsprite(3):resetsprite(4):GOTO finish_creature_placement
'hide sprite 4 if creature is squid or fish
IF creature>1 THEN resetsprite(4)
'randomize creature speed from 2 to 4 pixels/frame
creature1_Speed = RANDOM(3)+2
creature1_UpDown_Speed = RANDOM(2)+2
creature1_UpDown = RANDOM(2)
IF spawnPoint = 1 THEN Spritex(3)=40:Spritey(3)=25:creature1_Facing=1:IF creature<3 THEN Spritex(4)=Spritex(3)+8
IF spawnPoint = 2 THEN Spritex(3)=40:Spritey(3)=50:creature1_Facing=1:IF creature<3 THEN Spritex(4)=Spritex(3)+8
IF spawnPoint = 3 THEN Spritex(3)=40:Spritey(3)=75:creature1_Facing=1:IF creature<3 THEN Spritex(4)=Spritex(3)+8
IF spawnPoint = 4 THEN Spritex(3)=120:Spritey(3)=25:creature1_Facing=0:IF creature<3 THEN Spritex(4)=Spritex(3)-8
IF spawnPoint = 5 THEN Spritex(3)=120:Spritey(3)=50:creature1_Facing=0:IF creature<3 THEN Spritex(4)=Spritex(3)-8
IF spawnPoint = 6 THEN Spritex(3)=120:Spritey(3)=75:creature1_Facing=0:IF creature<3 THEN Spritex(4)=Spritex(3)-8
Spritey(4)=Spritey(3)

IF creature = 1 THEN #SpriteC(3)=SPR_GREY:#SpriteC(4)=SPR_GREY:GOTO finish_creature_placement
IF creature = 2 THEN #SpriteC(3)=SPR_PURPLE:GOTO finish_creature_placement
IF creature = 3 THEN #SpriteC(3)=SPR_WHITE:GOTO finish_creature_placement
IF creature >= 4 AND creature <= 6 THEN 
	'random color for fish
	IF spawnPoint = 1 THEN #SpriteC(3)=SPR_DARKGREEN
	IF spawnPoint = 2 THEN #SpriteC(3)=SPR_YELLOWGREEN
	IF spawnPoint = 3 THEN #SpriteC(3)=SPR_LIGHTBLUE	
	IF spawnPoint = 4 THEN #SpriteC(3)=SPR_PINK	
	IF spawnPoint = 5 THEN #SpriteC(3)=SPR_ORANGE
	IF spawnPoint = 6 THEN #SpriteC(3)=SPR_YELLOW
END IF 	
finish_creature_placement:

END

display_creature:   Procedure

ON creature GOTO finish_display_creature,display_shark,display_octopus,display_squid,display_fish1,display_fish2,display_fish3,,,,,,
'skip display creature code if creature>6
GOTO finish_display_creature

display_shark:
IF creature1_Facing=0 THEN 
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2, SPR45+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2, SPR45+ (8*creature1_frame) +#SpriteC(3)
	Sprite 4,Spritex(4)+VISIBLE+ZOOMX2,Spritey(4)+ZOOMY2, SPR47+ (8*creature1_frame) +#SpriteC(4)
ELSE	
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR45+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR45+ (8*creature1_frame) +#SpriteC(3)
	Sprite 4,Spritex(4)+VISIBLE+ZOOMX2,Spritey(4)+ZOOMY2+FLIPX, SPR47+ (8*creature1_frame) +#SpriteC(4)
END IF
GOTO finish_display_creature

display_octopus:
IF creature1_Facing=0 THEN 
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2, SPR49+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2, SPR49+ (8*creature1_frame) +#SpriteC(3)
ELSE	
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR49+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR49+ (8*creature1_frame) +#SpriteC(3)
END IF
GOTO finish_display_creature

display_squid:
IF creature1_Facing=0 THEN 
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2, SPR41+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2, SPR41+ (8*creature1_frame) +#SpriteC(3)
ELSE	
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR41+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR41+ (8*creature1_frame) +#SpriteC(3)
END IF
GOTO finish_display_creature

display_fish1:
IF creature1_Facing=0 THEN 
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2, SPR43+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2, SPR43+ (8*creature1_frame) +#SpriteC(3)
ELSE	
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR43+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR43+ (8*creature1_frame) +#SpriteC(3)
END IF
GOTO finish_display_creature

display_fish2:
IF creature1_Facing=0 THEN 
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2, SPR53+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2, SPR53+ (8*creature1_frame) +#SpriteC(3)
ELSE	
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR53+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR53+ (8*creature1_frame) +#SpriteC(3)
END IF
GOTO finish_display_creature

display_fish3:
IF creature1_Facing=0 THEN 
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2, SPR55+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2, SPR55+ (8*creature1_frame) +#SpriteC(3)
ELSE	
	''Sprite 3,Spritex(3)+VISIBLE+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR55+ (8*creature1_frame) +#SpriteC(3)
	Sprite 3,Spritex(3)+VISIBLE+HIT+ZOOMX2,Spritey(3)+ZOOMY2+FLIPX, SPR55+ (8*creature1_frame) +#SpriteC(3)
END IF
GOTO finish_display_creature

finish_display_creature:

wait
END

moveCreature:   Procedure
REM redirect creature when they reach the screen border
IF creature1_Facing = 0 THEN 
	spriteX(3)=spriteX(3)-creature1_Speed
	spriteX(4)=spriteX(3)+16
	''IF spriteX(3)<=0 THEN creature1_Facing=1:creature1_Speed = RANDOM(3)+2:GOTO finish_moveCreature
	IF spriteX(3)<=4 THEN creature1_Facing=1:creature1_Speed = RANDOM(3)+2:GOTO finish_moveCreature
END IF

IF creature1_Facing = 1 THEN 
	spriteX(3)=spriteX(3)+creature1_Speed
	spriteX(4)=spriteX(3)-16
	''IF spriteX(3)>=160 THEN creature1_Facing=0:creature1_Speed = RANDOM(3)+2:GOTO finish_moveCreature
	IF spriteX(3)>=156 THEN creature1_Facing=0:creature1_Speed = RANDOM(3)+2:GOTO finish_moveCreature
END IF

'only adjust up/down movement if creature-speed > 2  otherwise lateral movement only

IF creature1_speed > 2 THEN 
	IF creature1_UpDown = 0 THEN 
		spriteY(3)=spriteY(3)-creature1_UpDown_Speed
		spriteY(4)=spriteY(3)
		IF spriteY(3)<=4 THEN creature1_UpDown=1:creature1_UpDown_Speed = RANDOM(2)+2:GOTO finish_moveCreature
	END IF

	IF creature1_UpDown = 1 THEN 
		spriteY(3)=spriteY(3)+creature1_UpDown_Speed
		spriteY(4)=spriteY(3)
		IF spriteY(3)>=84 THEN creature1_UpDown=0:creature1_UpDown_Speed = RANDOM(2)+2:GOTO finish_moveCreature
	END IF
END IF

finish_moveCreature:

END


castle_walls:   Procedure

PLAY Simple
PLAY Castle_Tune

REM add the entryway(s) to the castle screens based on the grid layout
REM (nsew, ns, ew, ne, nw, se, sw, n, s, e, w, nse, nsw, new, sew)

'select a random castle grid
castleGrid = RANDOM(9)+1
ON castleGrid GOTO grid1, grid2, grid3, grid4, grid5, grid6, grid7, grid8, grid9
grid1:
RESTORE castleGrid1
GOTO gridData
grid2: 
RESTORE castleGrid2
GOTO gridData
grid3: 
RESTORE castleGrid3
GOTO gridData
grid4: 
RESTORE castleGrid4
GOTO gridData
grid5: 
RESTORE castleGrid5
GOTO gridData
grid6: 
RESTORE castleGrid6
GOTO gridData
grid7: 
RESTORE castleGrid7
GOTO gridData
grid8: 
RESTORE castleGrid8
GOTO gridData
grid9: 
RESTORE castleGrid9
GOTO gridData
gridData:
cls
screen castle_level
FOR A=1 TO 100
READ castleLayout(A)
NEXT A
'mermaid always enters the castle in room #95 
mermaid_CastleLocation = 95
mermaid_castleLocationX = 100-mermaid_CastleLocation
mermaid_castleLocationY = 100-(mermaid_CastleLocation-mermaid_CastleLocationX)
gosub display_castle_walls
END

REM (1=nsew, 2=ns, 3=ew, 4=ne, 5=nw, 6=se, 7=sw, 8=n, 9=s, 10=e, 11=w, 12=nse, 13=nsw, 14=new, 15=sew) 
REM (direction listed indicates opening to adjacent room)

display_castle_walls:   Procedure
on castleLayout(mermaid_CastleLocation) GOTO ,wall_nsew,wall_ns,wall_ew,wall_ne,wall_nw,wall_se,wall_sw,wall_n,wall_s,wall_e,wall_w,wall_nse,wall_nsw,wall_new,wall_sew,
wall_nsew:
'do nothing, default castle level is built in the nsew configuration
GOTO finish_display_castle_walls

wall_ns:
GOSUB close_east_wall
GOSUB close_west_wall
GOTO finish_display_castle_walls

wall_ew:
GOSUB close_north_wall
GOSUB close_south_wall
GOTO finish_display_castle_walls

wall_ne:
GOSUB close_south_wall
GOSUB close_west_wall
GOTO finish_display_castle_walls

wall_nw:
GOSUB close_south_wall
GOSUB close_east_wall
GOTO finish_display_castle_walls

wall_se:
GOSUB close_north_wall
GOSUB close_west_wall
GOTO finish_display_castle_walls

wall_sw:
GOSUB close_north_wall
GOSUB close_east_wall
GOTO finish_display_castle_walls

wall_n:
GOSUB close_south_wall
GOSUB close_east_wall
GOSUB close_west_wall
GOTO finish_display_castle_walls

wall_s:
GOSUB close_north_wall
GOSUB close_east_wall
GOSUB close_west_wall
GOTO finish_display_castle_walls

wall_e:
GOSUB close_north_wall
GOSUB close_south_wall
GOSUB close_west_wall
GOTO finish_display_castle_walls

wall_w:
GOSUB close_north_wall
GOSUB close_south_wall
GOSUB close_east_wall
GOTO finish_display_castle_walls

wall_nse:
GOSUB close_west_wall
GOTO finish_display_castle_walls

wall_nsw:
GOSUB close_east_wall
GOTO finish_display_castle_walls

wall_new:
GOSUB close_south_wall
GOTO finish_display_castle_walls

wall_sew:
GOSUB close_north_wall
GOTO finish_display_castle_walls

finish_display_castle_walls:

END

close_north_wall:   Procedure
PRINT AT 9, $1858
PRINT AT 10, $1858
END

close_south_wall:   Procedure
PRINT AT 229, $1858
PRINT AT 230, $1858
END

close_east_wall:   Procedure
PRINT AT 119, $1860
PRINT AT 139, $1860
END

close_west_wall:   Procedure
PRINT AT 100, $1860
PRINT AT 120, $1860
END


REM (1=nsew, 2=ns, 3=ew, 4=ne, 5=nw, 6=se, 7=sw, 8=n, 9=s, 10=e, 11=w, 12=nse, 13=nsw, 14=new, 15=sew)
REM (direction listed indicates opening to adjacent room)

castleGrid1:
DATA 6,15,11,6,15,7,6,15,15,7
DATA 12,13,10,1,5,2,12,5,4,13
DATA 12,14,7,8,6,13,4,7,6,13
DATA 12,11,12,15,1,1,7,12,1,13
DATA 12,3,14,1,1,5,12,14,14,13
DATA 2,6,7,12,13,10,13,6,7,2
DATA 2,4,1,1,1,7,4,1,5,2
DATA 12,15,5,4,1,1,11,4,15,13
DATA 8,12,7,6,1,5,6,7,12,13
DATA 10,14,14,14,14,3,5,4,14,5

castleGrid2:
DATA 10,15,7,6,3,3,7,9,6,7
DATA 6,14,5,2,10,3,1,13,12,13
DATA 2,6,3,14,15,7,12,5,12,13
DATA 2,2,6,7,4,13,8,6,5,2
DATA 4,13,12,1,11,12,15,13,6,13
DATA 9,2,12,13,6,14,1,13,4,5
DATA 12,13,4,13,2,9,4,14,15,11
DATA 2,4,11,2,2,12,15,15,1,7
DATA 4,15,15,13,2,12,1,1,1,5 
DATA 10,14,14,5,8,4,14,14,14,11

castleGrid3:
DATA 6,15,15,3,15,15,15,15,15,7
DATA 12,1,5,9,12,1,14,1,1,13
DATA 12,5,6,13,12,1,7,4,1,5
DATA 8,6,1,13,12,13,12,7,8,9 
DATA 6,1,1,13,12,5,12,1,15,5 
DATA 12,1,1,13,8,6,1,1,13,9 
DATA 12,14,14,1,15,1,1,5,12,13
DATA 12,15,7,4,1,14,5,6,1,5 
DATA 8,4,1,11,2,10,15,1,1,7 
DATA 10,3,5,10,14,11,4,14,14,5 

castleGrid4:
DATA 9,9,10,3,15,15,15,3,3,11
DATA 4,14,15,7,12,1,13,6,2,11
DATA 6,7,12,13,12,1,1,13,6,7
DATA 12,13,12,13,12,14,5,2,12,13
DATA 12,13,12,13,2,6,15,5,12,13
DATA 4,13,12,13,8,12,13,6,1,13
DATA 6,1,1,1,15,1,13,4,14,13
DATA 4,1,14,1,1,1,14,3,15,5
DATA 6,1,7,4,1,5,6,7,2,9
DATA 4,14,14,11,8,10,14,14,14,5 

castleGrid5:
DATA 6,15,15,7,9,10,15,11,9,9
DATA 4,14,1,13,12,3,14,3,5,2 
DATA 10,7,12,5,2,6,15,15,15,13 
DATA 9,2,2,6,5,12,1,1,1,13
DATA 2,2,2,2,10,14,14,14,1,13 
DATA 2,4,1,1,3,3,3,7,12,5 
DATA 4,3,5,2,10,3,7,4,1,11 
DATA 10,3,15,1,15,7,12,15,1,7
DATA 6,15,13,2,8,2,12,1,1,13 
DATA 4,14,5,4,3,5,4,14,14,5 

castleGrid6:
DATA 6,15,15,7,9,6,15,15,15,7
DATA 12,1,1,13,2,12,1,1,1,13
DATA 12,14,1,5,2,4,1,1,1,13 
DATA 8,6,5,6,1,7,4,1,14,5 
DATA 10,1,15,1,1,1,15,14,15,11 
DATA 9,4,1,1,1,1,5,6,1,7 
DATA 12,7,12,1,1,5,6,1,1,13 
DATA 12,1,13,4,13,6,1,1,1,13 
DATA 12,1,1,7,2,12,1,1,1,13 
DATA 4,14,14,5,8,4,14,14,14,5 

castleGrid7:
DATA 9,9,9,9,9,9,9,9,9,9
DATA 2,2,2,2,2,2,2,2,2,2
DATA 2,4,14,14,14,14,14,14,14,13
DATA 4,3,15,15,15,7,10,15,11,2
DATA 6,11,8,8,8,2,10,1,11,2 
DATA 2,9,9,9,6,1,3,14,11,2 
DATA 4,1,1,1,14,13,6,3,15,13
DATA 10,5,2,4,3,13,12,11,12,5 
DATA 6,7,2,6,7,2,4,3,14,7 
DATA 4,14,14,14,14,14,3,3,3,5 

castleGrid8:
DATA 6,3,3,15,15,15,15,3,3,7
DATA 2,9,9,2,12,1,13,6,11,2 
DATA 2,2,2,2,4,14,13,12,11,2 
DATA 12,14,14,1,15,3,1,14,3,13 
DATA 2,6,11,2,8,6,13,6,11,2 
DATA 2,12,11,2,9,4,13,12,11,2
DATA 12,14,3,1,14,3,1,14,3,13 
DATA 2,6,11,2,6,15,13,6,11,2 
DATA 2,2,10,13,4,14,13,12,11,2 
DATA 4,14,3,14,3,3,14,14,3,5 

castleGrid9:
DATA 6,15,15,15,11,10,15,15,15,7
DATA 12,14,1,1,3,3,1,14,14,13
DATA 2,9,4,1,7,6,13,6,11,2
DATA 12,1,11,12,13,12,13,12,7,2 
DATA 2,8,6,1,5,12,13,12,5,2 
DATA 12,3,14,1,3,14,1,14,3,13 
DATA 2,6,7,2,9,9,2,6,11,2 
DATA 2,4,13,2,2,2,2,12,7,2 
DATA 2,6,13,2,12,13,2,12,5,2 
DATA 4,14,14,14,14,14,14,14,3,5 

displayQueen:   Procedure
'place the queen's throne in the center of the screen
PRINT AT 69, $3E6E
PRINT AT 89, $3E76

'movement (0-ne,1-se,2-sw,3-nw)
IF spriteX(5) = 70 THEN queenMovement = 0
IF spriteY(5) = 28 THEN queenMovement = 1
IF spriteX(5) = 90 THEN queenMovement = 2
IF spriteY(5) = 68 THEN queenMovement = 3

ON queen_counter GOTO moveQueen,,moveQueen,
'move queen when queen_counter = 0 or 2 otherwise just display the queen
GOTO finish_display_queen

moveQueen:
ON queenMovement GOTO moveQueen_NE,moveQueen_SE,moveQueen_SW,moveQueen_NW

moveQueen_NE:
spriteX(5)=spriteX(5)+1:spriteY(5)=spriteY(5)-2
spriteX(6)=spriteX(5):spriteY(6)=spriteY(5)
spriteX(7)=spriteX(5)-16:spriteY(7)=spriteY(5)
GOTO finish_display_queen

moveQueen_SE:
spriteX(5)=spriteX(5)+1:spriteY(5)=spriteY(5)+2
spriteX(6)=spriteX(5):spriteY(6)=spriteY(5)
spriteX(7)=spriteX(5)-16:spriteY(7)=spriteY(5)
GOTO finish_display_queen

moveQueen_SW:
spriteX(5)=spriteX(5)-1:spriteY(5)=spriteY(5)+2
spriteX(6)=spriteX(5):spriteY(6)=spriteY(5)
spriteX(7)=spriteX(5)-16:spriteY(7)=spriteY(5)
GOTO finish_display_queen

moveQueen_NW:
spriteX(5)=spriteX(5)-1:spriteY(5)=spriteY(5)-2
spriteX(6)=spriteX(5):spriteY(6)=spriteY(5)
spriteX(7)=spriteX(5)-16:spriteY(7)=spriteY(5)
GOTO finish_display_queen

finish_display_queen:
queen_counter=queen_counter+1:if queen_counter>3 THEN queen_counter=0
if queen_counter=2 THEN queen_frame = queen_frame+1:IF queen_frame>1 THEN queen_frame = 0
Sprite 5,Spritex(5)+VISIBLE+ZOOMX2,Spritey(5)+ZOOMY2, SPR57+ (8*queen_frame) +#SpriteC(5)
Sprite 6,Spritex(6)+VISIBLE+ZOOMX2,Spritey(6)+ZOOMY2, SPR59+ (8*queen_frame) +#SpriteC(6)
Sprite 7,Spritex(7)+VISIBLE+ZOOMX2,Spritey(7)+ZOOMY2, SPR51+ (8*queen_frame) +#SpriteC(7)
END

creatureCollisionOcean:   Procedure
mermaid_oceanLocation = starting_point 
SCREEN screen_level : GOSUB treasure_placement : GOSUB creature_placement
END

creatureCollisionCastle:   Procedure
mermaid_CastleLocation = 95
mermaid_castleLocationX = 100-mermaid_CastleLocation
mermaid_castleLocationY = 100-(mermaid_CastleLocation-mermaid_CastleLocationX)
SCREEN castle_level : GOSUB display_castle_walls : GOSUB treasure_placement : GOSUB creature_placement
END

merColor:   Procedure
if mermaid = 1 then #mermaid_Color = SPR_GREEN
if mermaid = 2 then #mermaid_Color = SPR_PINK
if mermaid = 3 then #mermaid_Color = SPR_RED
if mermaid = 4 then #mermaid_Color = SPR_PURPLE
if mermaid = 5 then #mermaid_Color = SPR_BROWN
END

'check for 1UP
check1up:   Procedure
IF #score >= 2000 AND lives1UPFlag = 0 GOTO grant_extra_life
IF #score >= 4000 AND lives1UPFlag = 1 GOTO grant_extra_life
IF #score >= 6000 AND lives1UPFlag = 2 GOTO grant_extra_life
IF #score >= 8000 AND lives1UPFlag = 3 GOTO grant_extra_life
IF #score >= 10000 AND lives1UPFlag = 4 GOTO grant_extra_life
IF #score >= 20000 AND lives1UPFlag = 5 GOTO grant_extra_life ELSE goto finish_check1up

grant_extra_life: 
lives=lives+1:lives1UPFlag=lives1UPFlag+1:soundFlag=9:GOSUB loadSound

finish_check1up:

END

lose_life:   Procedure
lives=lives-1
if lives=0 GOTO game_over
'play music to indicate the countdown timer ran out
''PLAY Time_Expired_Tune
''gosub waitalittle
GOTO main
END

level_complete:   
#score=#score+1000 : GOSUB check1up
''PLAY Level_Complete_Tune
''GOSUB waitalittle
GOTO nextLevel

game_over:  
''PLAY Game_Over_Tune
''GOSUB waitalittle
'play music to indicate game over, keep final score, level detail on screen for five seconds before allowing player to restart

GOTO reset


Intro_Tune:	DATA 16

	MUSIC C4,-
	MUSIC G3,G4
	MUSIC F3,-
	MUSIC E3,E4

	MUSIC D4#,E3
	MUSIC C4#,G3
	MUSIC F4,E3
	MUSIC G4#,G3

	MUSIC C4,-
	MUSIC G3,G4
	MUSIC F3,-
	MUSIC E3,E4

	MUSIC D4#,E3
	MUSIC C4#,G3
	MUSIC F4,E3
	MUSIC G4#,G3

	MUSIC D4,-
	MUSIC B3,B5
	MUSIC B3,A5
	MUSIC A3,D5

	MUSIC D5#,-
	MUSIC C5#,B2
	MUSIC G4#,A2
	MUSIC F4#,D2

	MUSIC D4,-
	MUSIC B3,B5
	MUSIC B3,A5
	MUSIC A3,D5

	MUSIC D5#,-
	MUSIC C5#,B2
	MUSIC G4#,A2
	MUSIC F4#,D2

	MUSIC REPEAT
	
	'MUSIC STOP

Game_Tune:	DATA 16

	MUSIC A5,-
	MUSIC G5,A4
	MUSIC D5,-
	MUSIC E5,B4	

	MUSIC A6,-
	MUSIC G6,A3
	MUSIC D6,-
	MUSIC E6,B3		
	
	MUSIC REPEAT
	
	'MUSIC STOP	

Castle_Tune:  DATA 16
	
	MUSIC C3Z,-
	MUSIC C3Z,-
	MUSIC D3Z,-
	MUSIC E3Z,-
	MUSIC -,-
	MUSIC -,-
	MUSIC -,-
	MUSIC -,-
	
	MUSIC C3Z,-
	MUSIC C3Z,-
	MUSIC D3Z,-
	MUSIC E3Z,-
	MUSIC -,-
	MUSIC -,-
	MUSIC -,-
	MUSIC -,-

	MUSIC C2Z,-
	MUSIC C2Z,-
	MUSIC D2Z,-
	MUSIC E2Z,-
	MUSIC -,-
	MUSIC -,-
	MUSIC -,-
	MUSIC -,-

	MUSIC A2Z,-
	MUSIC A2Z,-
	MUSIC -,-
	MUSIC -,-
	MUSIC B2Z,-
	MUSIC B2Z,-
	MUSIC -,-
	MUSIC -,-

	MUSIC C3Z,-
	MUSIC C3Z,-
	MUSIC D3Z,-
	MUSIC E3Z,-
	MUSIC -,A4Y
	MUSIC -,G4Y
	MUSIC -,D4Y
	MUSIC -,E4Y
	
	MUSIC C3Z,-
	MUSIC C3Z,-
	MUSIC D3Z,-
	MUSIC E3Z,-
	MUSIC -,A5Y
	MUSIC -,G5Y
	MUSIC -,D5Y
	MUSIC -,E5Y

	MUSIC C2Z,-
	MUSIC C2Z,-
	MUSIC D2Z,-
	MUSIC E2Z,-
	MUSIC -,A4Y
	MUSIC -,G4Y
	MUSIC -,D4Y
	MUSIC -,E4Y

	MUSIC A2Z,-
	MUSIC A2Z,-
	MUSIC -,A5Y
	MUSIC -,G5Y
	MUSIC B2Z,-
	MUSIC B2Z,-
	MUSIC -,D5Y
	MUSIC -,E5Y
	
	MUSIC REPEAT
	
	'MUSIC STOP	

Level_Complete_Tune:  DATA 16

	MUSIC A2Z,-
	MUSIC A2Z,-
	MUSIC -,A5Y
	MUSIC -,G5Y
	MUSIC B2Z,-
	MUSIC B2Z,-
	MUSIC -,D5Y
	MUSIC -,E5Y

	MUSIC STOP

Time_Expired_Tune:  DATA 16

	MUSIC A2Z,-
	MUSIC A2Z,-
	MUSIC -,A5Y
	MUSIC -,G5Y
	MUSIC B2Z,-
	MUSIC B2Z,-
	MUSIC -,D5Y
	MUSIC -,E5Y

	MUSIC STOP
	
Game_Over_Tune:  DATA 16

	MUSIC A2Z,-
	MUSIC A2Z,-
	MUSIC -,A5Y
	MUSIC -,G5Y
	MUSIC B2Z,-
	MUSIC B2Z,-
	MUSIC -,D5Y
	MUSIC -,E5Y

	MUSIC STOP
	
	
sprites:
'mermaid1   (32)
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"
	BITMAP "##......"
	BITMAP "###.#..."
	BITMAP "..#....."
	BITMAP "...#...."

    BITMAP "........"
	BITMAP "........"
	BITMAP "........"
	BITMAP "##......"
	BITMAP "##......"
	BITMAP "..#.#..."
	BITMAP "...#...."
	BITMAP "....#..."

    BITMAP "........"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"
	BITMAP "##......"
	BITMAP "###.#..."
	BITMAP "...##..."
	BITMAP "........"	

    BITMAP "........"
	BITMAP "........"
	BITMAP "........"
	BITMAP "##......"
	BITMAP "##......"
	BITMAP "..#.#..."
	BITMAP "...#...."
	BITMAP "....#..."

'mermaid2   (36)
	BITMAP "........"
	BITMAP "........"
	BITMAP ".XXX...."
	BITMAP "XXX....X"
	BITMAP "...XXXXX"
	BITMAP "...X.XX."
	BITMAP "........"
	BITMAP "........"

    BITMAP "...X...."
	BITMAP ".XXX...."
	BITMAP "XX......"
	BITMAP "........"
	BITMAP "...XXXXX"
	BITMAP "...X.XXX"
	BITMAP "........"
	BITMAP "........"

    BITMAP "........"
	BITMAP "...XX..."
	BITMAP "..XX...."
	BITMAP "XX......"
	BITMAP "...XXXX."
	BITMAP "...X.XXX"
	BITMAP ".......X"
	BITMAP "........"	

    BITMAP "...X...."
	BITMAP ".XXX...."
	BITMAP "XX......"
	BITMAP "........"
	BITMAP "...XXXXX"
	BITMAP "...X.XXX"
	BITMAP "........"
	BITMAP "........"

'bubble (40)
    BITMAP "..XXXX.."
	BITMAP ".X....X."
	BITMAP "X......X"
	BITMAP "X......X"
	BITMAP "X......X"
	BITMAP "X......X"
	BITMAP ".X....X."
    BITMAP "..XXXX.."

'squid (41)
	BITMAP "XXX....."
	BITMAP "XXXX...."
	BITMAP "XXXX...."
	BITMAP "..XXX..."
	BITMAP ".XXXXXX."
	BITMAP "X.X..X.X"
	BITMAP ".X.X..X."
	BITMAP "..X.X..X"

	BITMAP ".XXX...."
	BITMAP ".XXXX..."
	BITMAP ".XXXX..."
	BITMAP "...XXX.."
	BITMAP "..XXXXXX"
	BITMAP ".X.X..X."
	BITMAP ".X.X..X."
	BITMAP "..X.X..X"

'fish1 (43)
	BITMAP "........"
	BITMAP "........"
	BITMAP ".XXX.XX."
	BITMAP "XXXXXXX."
	BITMAP ".XXX.XX."
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

	BITMAP "........"
	BITMAP "........"
	BITMAP ".XXX..X."
	BITMAP "XXXXXX.."
	BITMAP ".XXX..X."
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

'shark-left (45)
	BITMAP "........"
	BITMAP ".......X"
	BITMAP "....XXXX"
	BITMAP ".XXXX.XX"
	BITMAP "XXXXXXXX"
	BITMAP ".XXXXXXX"
	BITMAP "......XX"
	BITMAP "........"

	BITMAP "........"
	BITMAP ".......X"
	BITMAP "...XXXXX"
	BITMAP "XXXX.XXX"
	BITMAP "..XXXXXX"
	BITMAP "XXXXXXXX"
	BITMAP "......XX"
	BITMAP ".......X"


'shark-right (47)
	BITMAP "X......."
	BITMAP "X......."
	BITMAP "XXXXX.XX"
	BITMAP "XXXXXX.."
	BITMAP "XXXXXX.."
	BITMAP "XXXXX.XX"
	BITMAP "X..X...."
	BITMAP "X......."


moreSprites:
	BITMAP "X......."
	BITMAP "X......X"
	BITMAP "XXXXX.XX"
	BITMAP "XXXXXXX."
	BITMAP "XXXXXXX."
	BITMAP "XXXXX.XX"
	BITMAP "....X..X"
	BITMAP "X......."


'octopus  (49)
	BITMAP "..XXXXXX"
	BITMAP ".XX.XX.X"
	BITMAP ".XXXXXXX"
	BITMAP ".XXXXXXX"
	BITMAP ".XXXXXXX"
	BITMAP "X.X.X.X."
	BITMAP "X.X.X.X."
	BITMAP "X.X.X.X."

	BITMAP "........"
	BITMAP "..XXXXXX"
	BITMAP ".X.XX.XX"
	BITMAP ".XXXXXXX"
	BITMAP ".XXXXXXX"
	BITMAP "X.X.X.X."
	BITMAP "X.X.X.X."
	BITMAP ".X.X.X.X"
	
'queen's sceptre	(51)
	BITMAP "XX......"
	BITMAP "X.X....."
	BITMAP ".XX....."
	BITMAP "...X...."
	BITMAP "....X..."
	BITMAP ".....X.."
	BITMAP "......X."
	BITMAP ".......X"

	BITMAP "........"
	BITMAP ".XX....."
	BITMAP ".X.X...."
	BITMAP "..XX...."
	BITMAP "....X..."
	BITMAP ".....X.."
	BITMAP "......X."
	BITMAP ".......X"


'fish2 (53)
	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXX."
	BITMAP "...XXX.X"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXXX"
	BITMAP "...XX..."
	BITMAP ".....X.."
	BITMAP "........"
	BITMAP "........"
	
'fish3 (55)
	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXX."
	BITMAP "...XXX.X"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXXX"
	BITMAP "...XX..."
	BITMAP ".....X.."
	BITMAP "........"
	BITMAP "........"

'queen (57)
	BITMAP "...XXX.."
	BITMAP "......XX"
	BITMAP "..XXX..."
	BITMAP "........"
	BITMAP "..XXX..."
	BITMAP "...XXX.."
	BITMAP "..XXX..."
	BITMAP ".XXX...."

	BITMAP "....XXX."
	BITMAP ".......X"
	BITMAP "...XXX.."
	BITMAP "........"
	BITMAP "...XXX.."
	BITMAP "..XXX..."
	BITMAP "...XXX.."
	BITMAP "....XXX."

'queen2 (59)
	BITMAP "........"
	BITMAP "...XXX.."
	BITMAP "..X...X."
	BITMAP ".X.XXX.X"
	BITMAP "X......X"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

	BITMAP "........"
	BITMAP "...XXX.."
	BITMAP ".XX...XX"
	BITMAP "X..XXX.X"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

'fish6 (61)
	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXX."
	BITMAP "...XXX.X"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXXX"
	BITMAP "...XX..."
	BITMAP ".....X.."
	BITMAP "........"
	BITMAP "........"	

'fish7 (63)
	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXX."
	BITMAP "...XXX.X"
	BITMAP "........"
	BITMAP "........"
	BITMAP "........"

	BITMAP "........"
	BITMAP "........"
	BITMAP "...XXX.X"
	BITMAP "..XXXXXX"
	BITMAP "...XX..."
	BITMAP ".....X.."
	BITMAP "........"
	BITMAP "........"

end:
goto end
